<?php

namespace App\Controller;

use App\Repository\ArticleRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Attribute\Route;

class SearchController extends AbstractController
{
    #[Route('/tag/{tag}', name: 'app_search')]
    public function index(
        string $tag,
        ArticleRepository $articleRepository
    ): Response
    {
        $articles = $articleRepository->findByTag($tag);
        return $this->render('index/index.html.twig', [
            'tag' => $tag,
            'articles' => $articles
        ]);
    }
}
